Index: request.lisp
===================================================================
--- request.lisp	(revision 3371)
+++ request.lisp	(working copy)
@@ -131,10 +131,17 @@
 Content-Length header, it is assumed, that ALREADY-READ octets have
 already been read."
   (let* ((headers-in (headers-in request))
+         (transfer-encodings (header-in :transfer-encoding request))
          (content-length (when-let (content-length-header (cdr (assoc :content-length headers-in
                                                                       :test #'eq)))
                            (parse-integer content-length-header :junk-allowed t)))
          (content-stream (content-stream request)))
+    (when transfer-encodings
+      (setq transfer-encodings
+            (split "\\s*,\\*" transfer-encodings)))
+    (when (member "chunked" transfer-encodings :test #'string-equal)
+      (setf content-stream (make-chunked-stream content-stream))
+      (setf (chunked-stream-input-chunking-p content-stream) t))
     (setf (slot-value request 'raw-post-data)
           (cond (want-stream
                  (let ((stream (make-flexi-stream content-stream :external-format +latin-1+)))
Index: server.lisp
===================================================================
--- server.lisp	(revision 3371)
+++ server.lisp	(working copy)
@@ -497,7 +497,7 @@
               (when transfer-encodings
                 (setq transfer-encodings
                       (split "\\s*,\\*" transfer-encodings)))
-              (when (member "chunked" transfer-encodings :test #'equalp)
+              (when (member "chunked" transfer-encodings :test #'string-equal)
                 ;; turn chunking on before we read the request body
                 (setf *hunchentoot-stream* (make-chunked-stream *hunchentoot-stream*)
                       (chunked-stream-input-chunking-p *hunchentoot-stream*) t))))
